#include "TFile.h"
#include "TDirectory.h"
#include "TTree.h"
#include "TBranch.h"
#include <string>
#include "TKey.h"
#include "TLeaf.h"

using namespace std;

void extract(char * filename)
{
  TFile::SetReadaheadSize(10000);
  TFile * f = TFile::Open(filename); 
  f->ls();  
  TIter nextkey(gDirectory->GetListOfKeys());
  int i,j;
  while (key = (TKey*)nextkey()) {
    i++;
    TObject* obj = key->ReadObj();
    std::string name = obj->GetName();
    if(obj->IsA()->InheritsFrom("TTree")){
      TTree* tree = dynamic_cast<TTree*>(obj);
      tree->SetCacheSize(10000000);
      tree->AddBranchToCache("*");
      cout << endl;
      tree->ls();
      cout << endl;
      int count = tree->GetNbranches();
      cout << "List of branches" << endl;
      TIter branchIter(tree->GetListOfBranches());
      while(branch=branchIter()){
	cout << branch->GetName() << endl;
      }
      
      cout << "Iterating over all entries..." << endl;
      nEntries = tree->GetEntries();
      for( Long64_t iEntries=0; iEntries<nEntries; iEntries++){
	cout << "Entry size: " << tree->GetEntry(iEntries) << endl;
      }
      //TObject* branchObject = tree->GetBranch("physics");
      //cout << branchObject << endl;
      //branchObject->ls();
      //TBranch* branch = dynamic_cast<TBranch*>();
      //cout << branch->GetName() << endl;
      //branch->ls();
      /* TIter nextLeaf(branch->GetListOfLeaves());
      while( leaftmp=(TLeaf*)nextLeaf() ){
      	TLeaf* leaf = dynamic_cast<TLeaf*>(leaftmp);
      string leafName=leaf->GetName();
	//cout << leaf->GetName() << endl;
	}*/
    }
  }
  
}
